package de.twenty11.skysail.common.ext.osgimonitor;

import java.io.Serializable;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import javax.persistence.Transient;

import org.codehaus.jackson.annotate.JsonIgnore;
import org.osgi.framework.Bundle;
import org.osgi.framework.ServiceReference;

import de.twenty11.skysail.common.DetailsLinkProvider;

public class ServiceDescriptor implements DetailsLinkProvider, Serializable {

	private static final long serialVersionUID = -557374476304687619L;

	@Transient
	private Map<String, String> links;

	private BundleDescriptor providingBundle;
	
//	@Transient
//	private Bundle[] usingBundles;

	private Map<String, Object> properties = new HashMap<String,Object>();

	public ServiceDescriptor() {
	}
	
	public ServiceDescriptor(ServiceReference sr) {
		providingBundle = new BundleDescriptor(sr.getBundle());
		//usingBundles = sr.getUsingBundles();
		String[] propertyKeys = sr.getPropertyKeys();
		for (String key : propertyKeys) {
			properties.put(key, sr.getProperty(key));
		}
	}
	
	public Map<String, Object> getProperties() {
		return properties;
	}
	
	public void setProperties(Map<String, Object> properties) {
		this.properties = properties;
	}
	
	public BundleDescriptor getProvidingBundle() {
		return providingBundle;
	}
	
	public void setProvidingBundle(BundleDescriptor providingBundle) {
		this.providingBundle = providingBundle;
	}
	
//	public Bundle[] getUsingBundles() {
//		return usingBundles;
//	}
	
	@Override
	@JsonIgnore
	public Map<String, String> getLinkMap() {
		return Collections.emptyMap();
	}

	@Override
	public Map<String, String> getLinks() {
		return Collections.emptyMap();
	}

	@Override
	public void setLinks(Map<String, String> arg0) {
	}

}
